U.FxFactory = (function() {
    var obj = {};
    var repo = Lib.createRepo();

    function SingleRenderedAnim() {
        var self = this;

        this.create = function(opts) {
            var opts = opts || {};
            var self = this;
            // p("CReating single rendered anim");
            var x = Lib.check.isNumber(opts.x) ? opts.x : 100;
            var y = Lib.check.isNumber(opts.y) ? opts.y : 100;
            var texture = Lib.check.isGameTexture(opts.texture) ? opts.texture : "";
            if (Lib.check.isEmptyString(texture)) {
                Lib.glob.warn("Cant create Suicide Anim. No texture arg passed or texture wasn't loaded");
                return -1;
            }
            var group = Lib.check.objHasMethod(opts.group, "create") ? opts.group : undefined;
            var animSpeed = Lib.check.isNumber(opts.animSpeed) ? opts.animSpeed : 12;
            var delay = Lib.check.isNumber(opts.delay) ? opts.delay : 0;
            var scale = Lib.check.isNumber(opts.scale) ? opts.scale : 1;
            var anchor = Lib.check.objHasProps(opts.anchor, ["x", "y"]) ? opts.anchor : new Phaser.Point(0, 0);

            var sa = new Lib.FxObjects.SuicideAnim({
                x: x,
                y: y,
                texture: texture,
                group: group,
                animSpeed: animSpeed,
                delay: delay,
                anchor: anchor
            });

            sa.obj.scale.setTo(scale);
            return sa;
            // sa.obj.blendMode = Phaser.blendModes.ADD;

        }

    }
    obj.SingleRenderedAnim = SingleRenderedAnim;


    // function PhaserEmitter(){
    //     var self = this;
    //     var opts = opts || {};

    //     // var texture = 
    // }

    //
    return obj;
}());

U.LocalFx = {};
U.LocalFx.logAppears = function(x, y, scale) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    fxFactory.create({
        x: x,
        y: y,
        texture: "leafExplosion",
        animSpeed: 32,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: scale
    });
}

U.LocalFx.logDisappears = function(x, y, scale) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    var sa = fxFactory.create({
        x: x,
        y: y,
        texture: "implosion1",
        animSpeed: 42,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: scale
    });

}

U.LocalFx.ballAppears = function(x, y) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    var sa = fxFactory.create({
        x: x,
        y: y,
        texture: "ballAppearNormal",
        animSpeed: 32,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: 0.6
    });

}

U.LocalFx.ballDisappears = function(x, y) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    var sa = fxFactory.create({
        x: x,
        y: y,
        texture: "ballDisappearNormal",
        animSpeed: 22,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: 0.6
    });

}

U.LocalFx.ballOnFireAppears = function(x, y) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    fxFactory.create({
        x: x,
        y: y,
        texture: "leafExplosion",
        animSpeed: 32,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: 0.6
    });

}

U.LocalFx.ballOnFireDisappears = function(x, y) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    var sa = fxFactory.create({
        x: x,
        y: y,
        texture: "implosion1",
        animSpeed: 42,
        delay: 0,
        group: U.GLOB.GROUPS.ballAndBasketGroup,
        scale: 0.6
    });

}

U.LocalFx.smallGuiFx = function(x, y, scale, texture = "smallGuiFx", speed = 32, group = U.GLOB.GROUPS.aboveGui) {
    var fxFactory = U.GLOB.FACTORY.singleRenderedAnim;
    fxFactory.create({
        x: x,
        y: y,
        texture: texture,
        animSpeed: speed,
        delay: 0,
        group: U.GLOB.GROUPS.gui,
        scale: scale,
        anchor: new Phaser.Point(0.5, 0.5),
        group: group
    });
}

U.LocalFx.transitionScreen = function(seconds = 0.5) {

    if(Lib.check.exists(this.obj)){
        this.obj.destroy();
        p("EXISTS");
    }

    if(Lib.check.exists(this.alphaTween)){
        this.alphaTween.manager.remove(this.alphaTween);
    }

    this.obj = game.add.image(0, 0, "transitionScreen");
     this.obj.alpha = 0;
    var upSpeed = 0.5;
    var downSpeed = 1;
    var maxAlpha = 1;
    this.alphaTween = game.add.tween(this.obj);
    this.alphaTween.to({alpha:maxAlpha}, Phaser.Timer.SECOND * upSpeed, Phaser.Easing.Quadratic.Out);
    this.alphaTween.to({alpha:0}, Phaser.Timer.SECOND * downSpeed, Phaser.Easing.Quadratic.Out);

    this.alphaTween.start();

}
